Subject: RE: bug#41097: 28.0.50; (dired-toggle-marks) not working after copy

From: Drew Adams <[email-masked]>
Date: Sun, 10 May 2020 19:33:39 -0700 (PDT)

> > > Because t toggles marks, and C is not a mark, it's a flag.
> >
> > This is not true.  Let's please not go there.
> 
> But if you think so (and I somewhat agree), isn't then the first
> sentence in the docstring that Eli didn't touch:
> 
>   "Toggle marks: marked files become unmarked, and vice versa."
> 
> even more confusing?  I guess Eli wanted to avoid a sentence like "and
> files marked with marks other than the * mark don't count as marked."

I already agreed that the doc string could be clearer.
I suggested this:

  Toggle `*' marks: unmark marked files, and vice versa.

But perhaps this would be even better (since "those"
refers to "`*' marks"):

  Toggle `*' marks: unmark those marked, and vice versa.

Or (72 chars):

  Toggle `*' marks: unmark files marked `*'; mark unmarked files with `*'.

IOW, explicitly say that toggling applies to `*' marks.

> But the inconsistency goes much further, we say that commands operate
> on the "marked" files, but we mean only the *-marked files.

See above.  (Are you talking about `t' here still?
Why do you say "commands" (plural)?)

> So I guess the terminology is "marked with" applies to any mark and
> "marked" only to files marked with *, and "unmarked" means "doesn't
> have any mark".  Oh dear, it's like learning English modal verbs.

I don't understand.  Perhaps I'm missing something.
No, there's nothing special about "marked with".

`t' replaces all `*' marks with a space - unmarks them.
`t' replaces all unmarked (space) with a `*' mark.

> I think we can be more specific in the docstring, and I also don't like
> to introduce the second term "flag" here since it is somewhat linked to
> deletion indeed, and it's meaning is as fluent as "mark" - that doesn't
> help.

It's _entirely_ linked to deletion, in Dired.  Or it
was, until Eli's change.

> Ok, would something like this be a compromise?
> 
> - Toggle marks: marked files become unmarked, and vice versa.
> - Files marked with other flags (such as `D') are not affected.
> 
> + Toggle marks: marked files become unmarked, and vice versa.
> + This means that files marked with `*' are unmarked and files that
> don't
> + have any mark are marked with `*'.  Files marked with any
> + characters other than `*' are uneffected.

unaffected, not uneffected.

That text is fine by me, even if a bit verbose
("This means").

I'd still propose mentioning `*' in the first
sentence (the main one) - it's about `*' marks
(only).  But your text is clear enough, to me.

> (the term "marker character" is already used in the manual.)

FWIW I don't understand why you added that part
in parens to your message.